<?php

class myLCOoptions {

    protected $option_name = '_myLCO';
    protected $params = array (
        'category_name' => 'myLCO',
        'hide_invisible' => 0,
        'orderby' => 'url',
    );

    public function __construct () {
        $this->load ();
    }

    public function load () {
        $arr = get_option ($this->option_name);
        if (is_array ($arr)) {
            foreach ($arr as $key => $value) {
                $this->__set ($key, $value);
            }
            return TRUE;
        }
        return FALSE;
        
    }

    public function __get ($key) {
        return (isset ($this->params[$key]) ? $this->params[$key] : NULL);
    }

    public function __set ($key, $value) {
        $this->params[$key] = $value;
    }

    public function get () {
        return $this->params;
    }

    public function update () {
        update_option ($this->option_name, $this->get ());
    }

}

class myLCOpagerank extends myLCOoptions {

    protected $option_name = '_myLCO_pr';
    protected $params = array ();

    public function load () {
        $arr = get_option ($this->option_name);
        if (is_array ($arr)) {
            $yesterday = time () - 86400;
            foreach ($arr as $key => $value) {
                if ($yesterday < $value['time']) {
                    $this->__set ($key, $value);
                }
            }
        } else {
            add_option ($this->option_name, $this->get (), ' ', 'no');
        }
    }

    private function setPageRank ($url) {
        $arr = array ('pr' => 'N/A', 'time' => time ());
        $result = wp_remote_get ("http://webinfodb.net/a/pr.php?url=" . urlencode ($url));
        if ('200' == $result['response']['code']) {
            $arr['pr'] = (int) $result['body'];
            $this->__set ($url, $arr);
            $this->update ();
        }
        return $arr['pr'];
    }

    public function getPageRank ($url) {
        $result = $this->__get ($url);
        return (isset ($result['pr']) ? $result['pr'] : $this->setPageRank ($url));
    }

}

?>
